dataset_directory = '../dataset/';
calibration_file = '../calibration/40x_1x1_info.txt';
extra_params = [];

algorithm_name = 'algorithm_heuristic_search';

alg_handle = str2func(algorithm_name);

calibration_meta = read_metadata(calibration_file,[]);
calibration_tile = [0 0 calibration_meta.absolute_length];

extra_params.max_tile_row = 5;
extra_params.max_tile_col = 5;

%uncomment this if algorithm_name = 'algorithm_heuristic';
% extra_params.n_tile_row = 3;
% extra_params.n_tile_col = 3;
n_batches = 2;

cost = [];
x_data = 1;
image_name = {};


    list_images = dir([dataset_directory '/*.bmpmasked.bmp']);
    for x_image = 1:length(list_images)
        image_name{x_data} = list_images(x_image).name;
        
        im = imread([dataset_directory  '/' image_name{x_data}]);
        image_meta = read_metadata([dataset_directory '/' image_name{x_data}(1:end-14) '_info.txt'], ...
            im);
        [blobs,im_labels] = find_specimens(im);
        
% %         run the algorithm
        [regions] = feval(alg_handle, im,image_meta,extra_params);
        
        [cost_tmp,coverage_cost,time_cost] = compute_objective(regions,blobs,im_labels,calibration_tile,image_meta);
        
        cost(x_data) = cost_tmp;
        disp([image_name{x_data} ' coverage cost : ' num2str(coverage_cost) ' time cost: ' num2str(time_cost) ' total: ' num2str(cost_tmp) ]);
        x_data = x_data + 1;
    end


disp(['average cost: ' num2str(mean(cost))]);
