clear all;
close all;
% clc;


algorithm_name = 'algorithm_heuristic_search';
image_prefix = '../dataset/skin_001';
calibration_file = '../calibration/40x_1x1_info.txt';
extra_params.max_tile_row = 5;
extra_params.max_tile_col = 5;

%uncomment this if algorithm_name = 'algorithm_heuristic';
% extra_params.n_tile_row = 3;
% extra_params.n_tile_col = 3;

alg_handle = str2func(algorithm_name);

calibration_meta = read_metadata(calibration_file,[]);
calibration_tile = [0 0 calibration_meta.absolute_length];

image_filename = [image_prefix '.bmpmasked.bmp'];
image_meta_filename = [image_prefix '_info.txt'];

im = imread(image_filename);
image_meta = read_metadata(image_meta_filename, ...
            im);
[blobs,im_labels] = find_specimens(im);
        
% %         run the algorithm
[regions] = feval(alg_handle, im,image_meta,extra_params);
draw_regions(im,regions,image_meta);

[cost_tmp,coverage_cost,time_cost,autofocus_time,scanning_time] = compute_objective(regions,blobs,im_labels,calibration_tile,image_meta);
        
disp([image_filename ' coverage cost : ' num2str(coverage_cost) ' time cost: ' num2str(time_cost) ' total: ' num2str(cost_tmp) ]);
disp(['autofocus time: ' num2str(autofocus_time) ' scanning time: ' num2str(scanning_time)]);